/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.ryuuji.servlet.curso.asignatura.actividad;

import java.io.IOException;
import java.io.PrintWriter;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import logica.ExNihilo;
import logica.Search;
import orm.Actividad;
import orm.Asignatura;
import orm.Curso;

/**
 *
 * @author ryuuji
 */
@WebServlet(name = "EliminarActividad", urlPatterns = {"/EliminarActividad"})
public class EliminarActividad extends HttpServlet {

    /**
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code>
     * methods.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        try {

            SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
            String fechaString = request.getParameter("fecha");
            if (fechaString != null && !fechaString.equals("")) {
                Date fecha = format.parse(fechaString);

                String tipo = request.getParameter("tipo");
                if (tipo != null && !tipo.equals("")) {

                    String cursoString = request.getParameter("cursoEliminar");
                    if (cursoString != null && !cursoString.equals("")) {
                        int nivel = Integer.parseInt(cursoString.split("-")[0]);
                        String letra = cursoString.split("-")[1];
                        Curso curso = Search.buscarCurso(nivel, letra);

                        if (curso != null) {

                            String nombre = request.getParameter("asignaturaEliminar");
                            if (nombre != null && !nombre.equals("")) {
                                Asignatura asignatura = Search.buscarAsignatura(nombre, curso);

                                Actividad actividad = Search.buscarActividad(asignatura, fecha, tipo);
                                if (actividad != null) {
                                    if (ExNihilo.eliminarActividad(actividad)) {
                                        request.getRequestDispatcher("ActividadServlet").forward(request, response);
                                    } else {
                                        request.setAttribute("errorEliminar", "A ocurrido un error innesperado");
                                        request.getRequestDispatcher("ActividadServlet").forward(request, response);
                                    }
                                } else {
                                        request.setAttribute("errorEliminar", "La actividad no existe");
                                        request.getRequestDispatcher("ActividadServlet").forward(request, response);
                                    }
                            } else {
                                request.setAttribute("errorEliminar", "No hay asignatura seleccionada");
                                request.getRequestDispatcher("ActividadServlet").forward(request, response);
                            }
                        } else {
                            request.setAttribute("errorEliminar", "El curso no existe");
                            request.getRequestDispatcher("ActividadServlet").forward(request, response);
                        }
                    } else {
                        request.setAttribute("errorEliminar", "No hay curso seleccionado");
                        request.getRequestDispatcher("ActividadServlet").forward(request, response);
                    }
                } else {
                    request.setAttribute("errorEliminar", "Debe ingresar un tipo");
                    request.getRequestDispatcher("ActividadServlet").forward(request, response);
                }
            } else {
                request.setAttribute("errorEliminar", "No hay fecha seleccionada");
                request.getRequestDispatcher("ActividadServlet").forward(request, response);
            }

        } catch (ParseException ex) {
            request.setAttribute("errorEliminar", "La fecha es erronea");
            Logger.getLogger(CrearActividad.class.getName()).log(Level.SEVERE, null, ex);
            request.getRequestDispatcher("ActividadServlet").forward(request, response);
        }
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
